<!doctype html>
<!--
    Copyright (c) 2010, 2025 Contributors to the Eclipse Foundation

    See the NOTICE file(s) distributed with this work for additional
    information regarding copyright ownership.

    This program and the accompanying materials are made available under the terms
    of the MIT License which is available at https://opensource.org/licenses/MIT

    SPDX-License-Identifier: MIT
-->
<html lang="en">
    <head>
        <meta charset="utf-8">
        <meta name="viewport" content="width=device-width, initial-scale=1">
        <title>Module 4.7 | SBE Course</title>
        <link rel="icon" type="image/png" href="../sbe-course-favicon.png"/>

        <!-- Bootstrap. -->
        <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@5.1.1/dist/css/bootstrap.min.css" crossorigin="anonymous">
        <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap-icons@1.6.0/font/bootstrap-icons.css" crossorigin="anonymous">
        <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.1.1/dist/js/bootstrap.bundle.min.js" crossorigin="anonymous"></script>

        <!-- Website styling. -->
        <link rel="stylesheet" href="../../assets/eclipse-escet.css">
        <link rel="stylesheet" href="../../assets/eclipse-escet-sbe-course.css">

        <!-- Version selector. -->
        <script src="../../assets/eclipse-escet.js"></script>

        <!-- Code block syntax highlighting. -->
        <link rel="stylesheet" href="../../assets/styles/asciidoctor-highlightjs-escet.min.css">
        <script src="../../assets/highlight.min.js"></script>
        <script src="../../assets/languages/cif.min.js"></script>
        <script src="../../assets/languages/tooldef.min.js"></script>

        <!-- Quiz. -->
        <link rel="stylesheet" href="../assets/quiz.css">
        <script src="../assets/quiz.js"></script>

        <!-- SBE course. -->
        <link rel="stylesheet" href="../assets/course.css">
        <script src="../assets/course.js"></script>
    </head>

    <body class="escet-dark">

        <!-- Top navigation bar -->
        <nav class="navbar navbar-expand-lg navbar-dark escet-bg">
            <div class="container-fluid">
                <a class="navbar-brand d-lg-none">SBE Course</a>
                <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation">
                    <span class="navbar-toggler-icon"></span>
                </button>
                <div class="collapse navbar-collapse" id="navbarSupportedContent">
                    <ul class="navbar-nav me-auto mb-0 mb-lg-0">
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle escet-brand px-0" href="#" id="navbarDropdown" role="button" data-bs-toggle="dropdown" aria-expanded="false">Eclipse ESCET™ / SBE Course</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown">
                                <li><a class="dropdown-item" href="../.."><img src="../../eclipse-escet-favicon.png" class="pe-2"> Eclipse ESCET / Project</a></li>
                                <li><a class="dropdown-item" href=".."><img src="../sbe-course-favicon.png" class="pe-2"> Eclipse ESCET / SBE Course</a></li>
                                <li><a class="dropdown-item" href="../../cif"><img src="../../cif/cif-favicon.png" class="pe-2"> Eclipse ESCET / CIF</a></li>
                                <li><a class="dropdown-item" href="../../chi"><img src="../../chi/chi-favicon.png" class="pe-2"> Eclipse ESCET / Chi</a></li>
                                <li><a class="dropdown-item" href="../../tooldef"><img src="../../tooldef/tooldef-favicon.png" class="pe-2"> Eclipse ESCET / ToolDef</a></li>
                            </ul>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link" href="../" aria-expanded="false">Home</a>
                        </li>
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown1" role="button" data-bs-toggle="dropdown" aria-expanded="false">Module 1</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown1">
                                <li><a class="dropdown-item" href="../module1">Module 1: Supervisory control of discrete event systems</a></li>
                                <li><a class="dropdown-item" href="../module1/supervisory-control.html">Module 1.1: Supervisory control</a></li>
                                <li><a class="dropdown-item" href="../module1/discrete-event-systems.html">Module 1.2: Discrete event systems</a></li>
                                <li><a class="dropdown-item" href="../module1/modeling-discrete-event-systems.html">Module 1.3: Modeling discrete event systems</a></li>
                                <li><a class="dropdown-item" href="../module1/get-started-with-cif.html">Module 1.4: Get started with CIF</a></li>
                                <li><a class="dropdown-item" href="../module1/exercises.html">Module 1.5: Exercises</a></li>
                                <li><a class="dropdown-item" href="../module1/introduction-to-the-water-lock-case.html">Module 1.6: Introduction to the water lock case</a></li>
                            </ul>
                        </li>
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown2" role="button" data-bs-toggle="dropdown" aria-expanded="false">Module 2</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown2">
                                <li><a class="dropdown-item" href="../module2">Module 2: Working with automata</a></li>
                                <li><a class="dropdown-item" href="../module2/reachability-deadlock-blocking-livelock.html">Module 2.1: Reachability, deadlock, blocking and livelock</a></li>
                                <li><a class="dropdown-item" href="../module2/non-deterministic-automata.html">Module 2.2: Non-deterministic automata</a></li>
                                <li><a class="dropdown-item" href="../module2/synchronizing-automata.html">Module 2.3: Synchronizing automata</a></li>
                                <li><a class="dropdown-item" href="../module2/shared-variables.html">Module 2.4: Shared variables</a></li>
                                <li><a class="dropdown-item" href="../module2/computing-state-spaces.html">Module 2.5: Computing state spaces</a></li>
                                <li><a class="dropdown-item" href="../module2/cif-tools-view-analyze-models.html">Module 2.6: CIF tools to view and analyze models</a></li>
                                <li><a class="dropdown-item" href="../module2/constants-and-algebraic-variables.html">Module 2.7: Constants and algebraic variables</a></li>
                                <li><a class="dropdown-item" href="../module2/exercises.html">Module 2.8: Exercises</a></li>
                                <li><a class="dropdown-item" href="../module2/more-detailed-models-water-lock-case.html">Module 2.9: More detailed models for the water lock case</a></li>
                            </ul>
                        </li>
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown3" role="button" data-bs-toggle="dropdown" aria-expanded="false">Module 3</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown3">
                                <li><a class="dropdown-item" href="../module3">Module 3: Supervisory control and plant models</a></li>
                                <li><a class="dropdown-item" href="../module3/supervisory-control-loop.html">Module 3.1: Supervisory control loop</a></li>
                                <li><a class="dropdown-item" href="../module3/synthesis-guarantees.html">Module 3.2: Synthesis guarantees</a></li>
                                <li><a class="dropdown-item" href="../module3/supervisory-controller-synthesis.html">Module 3.3: Supervisory controller synthesis</a></li>
                                <li><a class="dropdown-item" href="../module3/modeling-larger-systems.html">Module 3.4: Modeling larger systems</a></li>
                                <li><a class="dropdown-item" href="../module3/exercises.html">Module 3.5: Exercises</a></li>
                                <li><a class="dropdown-item" href="../module3/water-lock-case-plant-models.html">Module 3.6: Water lock case plant models</a></li>
                            </ul>
                        </li>
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle active" aria-current="page" href="#" id="navbarDropdown4" role="button" data-bs-toggle="dropdown" aria-expanded="false">Module 4</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown4">
                                <li><a class="dropdown-item" href="./">Module 4: Modeling requirements and supervisor synthesis</a></li>
                                <li><a class="dropdown-item" href="user-specified-requirements.html">Module 4.1: User-specified requirements</a></li>
                                <li><a class="dropdown-item" href="requirement-automata-and-invariants.html">Module 4.2: Requirements automata and invariants</a></li>
                                <li><a class="dropdown-item" href="synthesis-with-requirements.html">Module 4.3: Synthesis with requirements</a></li>
                                <li><a class="dropdown-item" href="modeling-for-synthesis.html">Module 4.4: Modeling for synthesis</a></li>
                                <li><a class="dropdown-item" href="performing-synthesis-with-cif.html">Module 4.5: Performing synthesis with CIF</a></li>
                                <li><a class="dropdown-item" href="introduction-to-svg-visualization.html">Module 4.6: Introduction to SVG visualization</a></li>
                                <li><a class="dropdown-item active" aria-current="page" href="exercises.html">Module 4.7: Exercises</a></li>
                                <li><a class="dropdown-item" href="water-lock-case-requirements-and-supervisor.html">Module 4.8: Water lock case requirements and supervisor</a></li>
                            </ul>
                        </li>
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown5" role="button" data-bs-toggle="dropdown" aria-expanded="false">Module 5</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown5">
                                <li><a class="dropdown-item" href="../module5">Module 5: Hybrid simulation models</a></li>
                                <li><a class="dropdown-item" href="../module5/timed-and-hybrid-models.html">Module 5.1: Timed and hybrid models</a></li>
                                <li><a class="dropdown-item" href="../module5/variable-time.html">Module 5.2: Variable 'time'</a></li>
                                <li><a class="dropdown-item" href="../module5/continuous-variables.html">Module 5.3: Continuous variables</a></li>
                                <li><a class="dropdown-item" href="../module5/urgency.html">Module 5.4: Urgency</a></li>
                                <li><a class="dropdown-item" href="../module5/tau-event.html">Module 5.5: The 'tau' event</a></li>
                                <li><a class="dropdown-item" href="../module5/exercises.html">Module 5.6: Exercises</a></li>
                                <li><a class="dropdown-item" href="../module5/water-lock-case-hybrid-model.html">Module 5.7: Water lock case hybrid model</a></li>
                                <li><a class="dropdown-item" href="../module5/course-conclusion.html">Module 5.8: Course conclusion</a></li>
                            </ul>
                        </li>
                    </ul>
                </div>
            </div>
        </nav>

        <!-- Intro -->
        <div id="intro" class="position-relative p-3 text-center escet-bg escet-bg-opacity-125">
            <div class="clearfix mb-4 mb-md-0">
                <span class="float-end">
                    Version:
                    <div class="dropdown d-inline-block">
                        <a class="dropdown-toggle" href="#" role="button" id="versionDropdown" data-bs-toggle="dropdown" aria-expanded="false">@@ESCET-VERSION-ENDUSER@@</a>
                        <ul id="versions-dropdown" class="dropdown-menu dropdown-menu-end" aria-labelledby="versionDropdown" data-this-version="/@@ESCET-DEPLOY-FOLDER-NAME@@">
                            <li><h6 id="versions-previews" class="dropdown-header">Previews</h6></li>
                            <li><h6 id="versions-latest-releases" class="dropdown-header">Latest releases</h6></li>
                            <li><h6 class="dropdown-header">Other</h6></li>
                            <li><a class="dropdown-item" href="../../versions.html">All versions...</a></li>
                        </ul>
                    </div>
                    <a class="text-nowrap ms-3" href="../../release-notes.html">[release notes]</a>
                </span>
            </div>
        </div>

        <!-- Content -->
        <div class="px-4 pt-5">
            <div class="row justify-content-center">
                <div class="col-12 col-md-10 col-xl-8 col-xxl-6" id="content">

                    <h1>Module 4.7: Exercises</h1>
                    <p>
                        You will now practice what you have learned in this third module.
                        When modeling, there is generally not one correct answer, as multiple solutions are possible.
                        After you complete an exercise, an example solution is given, together with an explanation.
                    </p>

                    <h2>Exercise 1</h2>
                    <p>
                        Consider a system that consists of a button and a lamp.
                        Pressing the button once turns on the lamp, and pressing it again turns off the lamp.
                    </p>
                    <p>
                        <strong>a. Model the plant and requirement automata for this system, synthesize a supervisor from it, and validate the result using simulation with the state visualizer.</strong>
                    </p>
                    <p>
                        Use a single requirement automaton and no requirement invariants.
                    </p>
                    <div class="accordion" id="exercise1a-accordion">
                        <div class="accordion-item">
                            <h2 class="accordion-header">
                                <button class="accordion-button collapsed" type="button" data-bs-toggle="collapse" data-bs-target="#exercise1a-solution" aria-expanded="false" aria-controls="exercise1a-solution">
                                    Show solution
                                </button>
                            </h2>
                            <div id="exercise1a-solution" class="accordion-collapse collapse" data-bs-parent="#exercise1a-accordion">
                                <div class="accordion-body">
                                    <p>
                                        The requirement essentially tracks whether the button is pushed an even or odd number of times.
                                        Depending on this, it decides whether the lamp may be turned on or off.
                                    </p>
                                    <pre class="highlightjs highlight">
                                        <code class="language-cif hljs" data-lang="cif">
                                            plant button:
                                                uncontrollable u_pushed, u_released;

                                                location Released:
                                                    initial;
                                                    marked;
                                                    edge u_pushed goto Pushed;

                                                location Pushed:
                                                    edge u_released goto Released;
                                            end

                                            plant lamp:
                                                controllable c_on, c_off;

                                                location Off:
                                                    initial;
                                                    marked;
                                                    edge c_on goto On;

                                                location On:
                                                    edge c_off goto Off;
                                            end

                                            requirement invert_by_push:
                                                location Even:
                                                    initial;
                                                    marked;
                                                    edge lamp.c_off;
                                                    edge button.u_pushed goto Odd;
                                                location Odd:
                                                    edge lamp.c_on;
                                                    edge button.u_pushed goto Even;
                                            end
                                        </code>
                                    </pre>
                                    <p>
                                        The synthesized supervisor does not impose any additional restrictions.
                                        The requirements are enough to ensure a proper supervisor.
                                    </p>
                                </div>
                            </div>
                        </div>
                    </div>
                    <p>
                        <strong>b. Now replace the requirement automaton by state/event exclusion invariants. What else do you need to change? Then synthesize a supervisor and validate it using simulation with the state visualizer.</strong>
                    </p>
                    <div class="accordion" id="exercise1b-accordion">
                        <div class="accordion-item">
                            <h2 class="accordion-header">
                                <button class="accordion-button collapsed" type="button" data-bs-toggle="collapse" data-bs-target="#exercise1b-solution" aria-expanded="false" aria-controls="exercise1b-solution">
                                    Show solution
                                </button>
                            </h2>
                            <div id="exercise1b-solution" class="accordion-collapse collapse" data-bs-parent="#exercise1b-accordion">
                                <div class="accordion-body">
                                    <p>
                                        The requirement can be changed to state/event exclusion invariants, but we still need to track even/odd button pushes.
                                        Thus, that part of the requirement automaton is changed to a plant.
                                        It is essentially an observer, that observes the number of button pushes.
                                        It does not limit the plant behavior.
                                        We could make it a monitor, but since in every location the <code>u_pushed</code> event is already present, that is not needed.
                                    </p>
                                    <pre class="highlightjs highlight">
                                        <code class="language-cif hljs" data-lang="cif">
                                            plant button:
                                                uncontrollable u_pushed, u_released;

                                                location Released:
                                                    initial;
                                                    marked;
                                                    edge u_pushed goto Pushed;

                                                location Pushed:
                                                    edge u_released goto Released;
                                            end

                                            plant lamp:
                                                controllable c_on, c_off;

                                                location Off:
                                                    initial;
                                                    marked;
                                                    edge c_on goto On;

                                                location On:
                                                    edge c_off goto Off;
                                            end

                                            plant observer:
                                                location Even:
                                                    initial;
                                                    marked;
                                                    edge button.u_pushed goto Odd;

                                                location Odd:
                                                    edge button.u_pushed goto Even;
                                            end

                                            requirement lamp.c_off needs observer.Even;
                                            requirement lamp.c_on  needs observer.Odd;
                                        </code>
                                    </pre>
                                </div>
                            </div>
                        </div>
                    </div>
                    <p>
                        <strong>c. Why should you not use state requirement invariants to model the requirements for this system?</strong>
                    </p>
                    <div class="accordion" id="exercise1c-accordion">
                        <div class="accordion-item">
                            <h2 class="accordion-header">
                                <button class="accordion-button collapsed" type="button" data-bs-toggle="collapse" data-bs-target="#exercise1c-solution" aria-expanded="false" aria-controls="exercise1c-solution">
                                    Show solution
                                </button>
                            </h2>
                            <div id="exercise1c-solution" class="accordion-collapse collapse" data-bs-parent="#exercise1c-accordion">
                                <div class="accordion-body">
                                    <p>
                                        All states of the system should remain present, and only certain transitions in certain states should be prevented.
                                        A state requirement invariant can not restrict transitions, but only prevent certain states from being reached.
                                    </p>
                                </div>
                            </div>
                        </div>
                    </div>

                    <h2>Exercise 2</h2>
                    <p>
                        Consider again the system with three machines from <a href="../module3/exercises.html#exercise4">Exercise 4 of Module 3</a>.
                    </p>
                    <p>
                        <strong>a. Specify a requirement automaton without guards that ensures that at most one machine is off at any particular moment.</strong>
                    </p>
                    <p>
                        Model it in CIF, synthesize a supervisor for it, and validate the result.
                    </p>
                    <div class="accordion" id="exercise2a-accordion">
                        <div class="accordion-item">
                            <h2 class="accordion-header">
                                <button class="accordion-button collapsed" type="button" data-bs-toggle="collapse" data-bs-target="#exercise2a-solution" aria-expanded="false" aria-controls="exercise2a-solution">
                                    Show solution
                                </button>
                            </h2>
                            <div id="exercise2a-solution" class="accordion-collapse collapse" data-bs-parent="#exercise2a-accordion">
                                <div class="accordion-body">
                                    <p>
                                        All machines are initially on.
                                        Since at most one of them may be off at any time, turning off one machine means that it must be started again before any machine may be turned off after that.
                                    </p>
                                    <pre class="highlightjs highlight">
                                        <code class="language-cif hljs" data-lang="cif">
                                            controllable o1, s1;
                                            controllable o2, s2;
                                            controllable o3, s3;

                                            plant machine1:
                                                location On:
                                                    initial;
                                                    marked;
                                                    edge s2;
                                                    edge o1 goto Off;

                                                location Off:
                                                    edge s1 goto On;
                                            end

                                            plant machine2:
                                                location On:
                                                    initial;
                                                    marked;
                                                    edge s3;
                                                    edge o2 goto Off;

                                                location Off:
                                                    edge s2 goto On;
                                            end

                                            plant machine3:
                                                location On:
                                                    initial;
                                                    marked;
                                                    edge s1;
                                                    edge o3 goto Off;

                                                location Off:
                                                    edge s3 goto On;
                                            end

                                            requirement AtMostOneOff:
                                                location AllOn:
                                                    initial;
                                                    marked;
                                                    edge o1 goto Off1;
                                                    edge o2 goto Off2;
                                                    edge o3 goto Off3;

                                                location Off1:
                                                    edge s1 goto AllOn;

                                                location Off2:
                                                    edge s2 goto AllOn;

                                                location Off3:
                                                    edge s3 goto AllOn;
                                            end
                                        </code>
                                    </pre>
                                </div>
                            </div>
                        </div>
                    </div>
                    <p>
                        <strong>b. Replace the requirement automaton by one or more state requirement invariants.</strong>
                    </p>
                    <p>
                        Model it in CIF, synthesize a supervisor for it, and validate the result.
                        Can you think of different ways to model the state requirement invariants?
                    </p>
                    <div class="accordion" id="exercise2b-accordion">
                        <div class="accordion-item">
                            <h2 class="accordion-header">
                                <button class="accordion-button collapsed" type="button" data-bs-toggle="collapse" data-bs-target="#exercise2b-solution" aria-expanded="false" aria-controls="exercise2b-solution">
                                    Show solution
                                </button>
                            </h2>
                            <div id="exercise2b-solution" class="accordion-collapse collapse" data-bs-parent="#exercise2b-accordion">
                                <div class="accordion-body">
                                    <p>
                                        The event declarations and plant automata remain unchanged.
                                        The requirement automaton can for instance be replaced by the following state requirement invariant, which indicates that at all times at least two machines are on:
                                    </p>
                                    <pre class="highlightjs highlight">
                                        <code class="language-cif hljs" data-lang="cif">
                                            requirement (machine1.On and machine2.On)
                                                     or (machine2.On and machine3.On)
                                                     or (machine3.On and machine1.On);
                                        </code>
                                    </pre>
                                    <p>
                                        We can also express that no two machines may be off at the same time:
                                    </p>
                                    <pre class="highlightjs highlight">
                                        <code class="language-cif hljs" data-lang="cif">
                                            requirement not (machine1.Off and machine2.Off);
                                            requirement not (machine2.Off and machine3.Off);
                                            requirement not (machine3.Off and machine1.Off);
                                        </code>
                                    </pre>
                                    <p>
                                        We can also count the number of machines that are off, and specify that this must be at most one.
                                    </p>
                                    <pre class="highlightjs highlight">
                                        <code class="language-cif hljs" data-lang="cif">
                                            requirement if machine1.Off: 1 else 0 end
                                                      + if machine2.Off: 1 else 0 end
                                                      + if machine3.Off: 1 else 0 end
                                                      <= 1;
                                        </code>
                                    </pre>
                                    <p>
                                        Here we use an <code>if</code> expression per machine to count <code>1</code> if it is off, and <code>0</code> if it is on.
                                        We add them up using <code>+</code>.
                                        And we express as requirement that this sum must be at most one.
                                    </p>
                                </div>
                            </div>
                        </div>
                    </div>
                    <p>
                        <strong>c. Replace the state requirement invariants by state/event exclusion requirements.</strong>
                    </p>
                    <p>
                        Model it in CIF, synthesize a supervisor for it, and validate the result.
                        Can you think of both <code><strong>needs</strong></code> and <code><strong>disables</strong></code> variants?
                    </p>
                    <div class="accordion" id="exercise2c-accordion">
                        <div class="accordion-item">
                            <h2 class="accordion-header">
                                <button class="accordion-button collapsed" type="button" data-bs-toggle="collapse" data-bs-target="#exercise2c-solution" aria-expanded="false" aria-controls="exercise2c-solution">
                                    Show solution
                                </button>
                            </h2>
                            <div id="exercise2c-solution" class="accordion-collapse collapse" data-bs-parent="#exercise2c-accordion">
                                <div class="accordion-body">
                                    <p>
                                        An example of using <code><strong>needs</strong></code> state/event exclusion requirements could be:
                                    </p>
                                    <pre class="highlightjs highlight">
                                        <code class="language-cif hljs" data-lang="cif">
                                            requirement o1 needs machine2.On and machine3.On;
                                            requirement o2 needs machine1.On and machine3.On;
                                            requirement o3 needs machine1.On and machine2.On;
                                        </code>
                                    </pre>
                                    <p>
                                        An example of using <code><strong>disables</strong></code> state/event exclusion requirements could be:
                                    </p>
                                    <pre class="highlightjs highlight">
                                        <code class="language-cif hljs" data-lang="cif">
                                            requirement machine1.Off disables {o2, o3};
                                            requirement machine2.Off disables {o1, o3};
                                            requirement machine3.Off disables {o1, o2};
                                        </code>
                                    </pre>
                                </div>
                            </div>
                        </div>
                    </div>

                    <h2 id="exercise3">Exercise 3</h2>
                    <p>
                        Consider a building with three floors.
                        There is an elevator that connects the floors.
                        At each floor, there is a sensor that detects that the elevator is at that floor.
                        Initially, the elevator stands still at the bottom floor.
                        The elevator can be told to go up a floor, or go down a floor.
                    </p>
                    <p>
                        <strong>a. Model the plants of this system.</strong>
                    <p>
                        Think of what states should be reachable, and what events should be possible in each state.
                        Validate your plant model.
                    </p>
                    <div class="accordion" id="exercise3a-accordion">
                        <div class="accordion-item">
                            <h2 class="accordion-header">
                                <button class="accordion-button collapsed" type="button" data-bs-toggle="collapse" data-bs-target="#exercise3a-solution" aria-expanded="false" aria-controls="exercise3a-solution">
                                    Show solution
                                </button>
                            </h2>
                            <div id="exercise3a-solution" class="accordion-collapse collapse" data-bs-parent="#exercise3a-accordion">
                                <div class="accordion-body">
                                    <p>
                                        We define <code>Sensor</code> as an automaton definition, to instantiate it once for each floor.
                                        Since the initial state is different between sensors, we use a parameter for this.
                                        The elevator has three states, for the floors it can be on.
                                        It can move up and down between floors.
                                        The sensors need to go on and off when the elevator moves between floors.
                                        The connection is made through guards in the sensor automata.
                                        A location parameter is used to provide the location of the elevator that indicates that the particular sensor should be on.
                                    </p>
                                    <pre class="highlightjs highlight">
                                        <code class="language-cif hljs" data-lang="cif">
                                            plant def Sensor(alg bool initialOn; location isOn):
                                                uncontrollable u_on, u_off;

                                                location Off:
                                                    initial not initialOn;
                                                    marked not initialOn;
                                                    edge u_on  when     isOn goto On;

                                                location On:
                                                    initial initialOn;
                                                    marked initialOn;
                                                    edge u_off when not isOn goto Off;
                                            end

                                            sensor_top:    Sensor(false, elevator.Top);
                                            sensor_middle: Sensor(false, elevator.Middle);
                                            sensor_bottom: Sensor(true,  elevator.Bottom);

                                            plant elevator:
                                                controllable c_up, c_down;

                                                location Bottom:
                                                    initial;
                                                    marked;
                                                    edge c_up goto Middle;

                                                location Middle:
                                                    edge c_down goto Bottom;
                                                    edge c_up goto Top;

                                                location Top:
                                                    edge c_down goto Middle;
                                            end
                                        </code>
                                    </pre>
                                </div>
                            </div>
                        </div>
                    </div>
                    <p>
                        <strong>b. Ensure that the elevator can only go from top to bottom and bottom to top, and can not reverse direction in the middle.</strong>
                    <p>
                        Add only requirements for this.
                        Think of how you could model this with different kinds of requirements, and what is the best way.
                        Synthesize a supervisor and validate the result.
                    </p>
                    <div class="accordion" id="exercise3b-accordion">
                        <div class="accordion-item">
                            <h2 class="accordion-header">
                                <button class="accordion-button collapsed" type="button" data-bs-toggle="collapse" data-bs-target="#exercise3b-solution" aria-expanded="false" aria-controls="exercise3b-solution">
                                    Show solution
                                </button>
                            </h2>
                            <div id="exercise3b-solution" class="accordion-collapse collapse" data-bs-parent="#exercise3b-accordion">
                                <div class="accordion-body">
                                    <p>
                                        The restriction that is needed, is that if the elevator is in the middle, it can only continue to go in the direction it is already going.
                                        We must therefore keep track of this direction.
                                        We can easily do this using a requirement automaton.
                                    </p>
                                    <pre class="highlightjs highlight">
                                        <code class="language-cif hljs" data-lang="cif">
                                            requirement NoReverse:
                                                location Bottom:
                                                    initial;
                                                    marked;
                                                    edge elevator.c_up goto GoingUp;

                                                location GoingUp:
                                                    edge elevator.c_up goto Top;

                                                location Top:
                                                    edge elevator.c_down goto GoingDown;

                                                location GoingDown:
                                                    edge elevator.c_down goto Bottom;
                                            end
                                        </code>
                                    </pre>
                                </div>
                            </div>
                        </div>
                    </div>

                    <h2>Exercise 4</h2>
                    <p>
                        Consider a system with two buttons and a lamp.
                        If the first button is pushed, and then the second button is pushed, the lamp may be turned on.
                        If the second button is pushed again, and then the first button is pushed again, the lamp may be turned off again.
                        Model this using plant automata and state/event requirement invariants.
                    </p>
                    <p>
                        Hint: Add an observer to the plant and make it a monitor.
                    </p>
                    <div class="accordion" id="exercise4-accordion">
                        <div class="accordion-item">
                            <h2 class="accordion-header">
                                <button class="accordion-button collapsed" type="button" data-bs-toggle="collapse" data-bs-target="#exercise4-solution" aria-expanded="false" aria-controls="exercise4-solution">
                                    Show solution
                                </button>
                            </h2>
                            <div id="exercise4-solution" class="accordion-collapse collapse" data-bs-parent="#exercise4-accordion">
                                <div class="accordion-body">
                                    <p>
                                        Since we have two buttons, we make a plant definition and instantiate it twice.
                                        There is only one lamp, so it can be modeled as an automaton.
                                        The observer plant tracks button pushes and releases.
                                        To ensure that we don't block button pushes and releases, we make it a monitor.
                                        The state/event exclusion requirements are then expressed using the state of the observer.
                                    </p>
                                    <pre class="highlightjs highlight">
                                        <code class="language-cif hljs" data-lang="cif">
                                            plant def Button():
                                                uncontrollable u_pushed, u_released;

                                                location Released:
                                                    initial;
                                                    marked;
                                                    edge u_pushed   goto Pushed;

                                                location Pushed:
                                                    edge u_released goto Released;
                                            end

                                            button1: Button();
                                            button2: Button();

                                            plant lamp:
                                                controllable c_on, c_off;

                                                location Off:
                                                    initial;
                                                    marked;
                                                    edge c_on  goto On;

                                                location On:
                                                    edge c_off goto Off;
                                            end

                                            plant observer:
                                                monitor;

                                                location Off:
                                                    initial;
                                                    marked;
                                                    edge button1.u_pushed goto On1;

                                                location On1:
                                                    edge button2.u_pushed goto On;

                                                location On:
                                                    edge button2.u_released goto Off2;

                                                location Off2:
                                                    edge button1.u_released goto Off;
                                            end

                                            requirement lamp.c_on  needs observer.On;
                                            requirement lamp.c_off needs observer.Off;
                                        </code>
                                    </pre>
                                </div>
                            </div>
                        </div>
                    </div>

                    <h2>Exercise 5</h2>
                    <p>
                        Consider a counter, that can be incremented and decremented by one through events.
                        The count itself is modeled as a ranged integer variable, with lower bound zero and upper bound eight (both inclusive).
                        Let synthesis ensure that the variable stays within its range, rather than modeling this yourself.
                        Explain the guards of the synthesized supervisor automaton.
                    </p>
                    <div class="accordion" id="exercise5-accordion">
                        <div class="accordion-item">
                            <h2 class="accordion-header">
                                <button class="accordion-button collapsed" type="button" data-bs-toggle="collapse" data-bs-target="#exercise5-solution" aria-expanded="false" aria-controls="exercise5-solution">
                                    Show solution
                                </button>
                            </h2>
                            <div id="exercise5-solution" class="accordion-collapse collapse" data-bs-parent="#exercise5-accordion">
                                <div class="accordion-body">
                                    <p>
                                        The counter is modeled as a plant automaton.
                                        The count itself is stored in a discrete variable with type <code>int[0..8]</code>.
                                        The events to increment and decrement the count are controllable events, such that synthesis can restrict them:
                                    </p>
                                    <pre class="highlightjs highlight">
                                        <code class="language-cif hljs" data-lang="cif">
                                            plant counter:
                                                disc int[0..8] count;
                                                controllable c_inc, c_dec;

                                                location:
                                                    initial;
                                                    marked;
                                                    edge c_dec do count := count - 1;
                                                    edge c_inc do count := count + 1;
                                            end
                                        </code>
                                    </pre>
                                    <p>
                                        Synthesis will figure out that if <code>count</code> has its lowest value, zero, decrementing it is not possible.
                                        And that if <code>count</code> has its highest value, eight, incrementing it is not possible.
                                        Hence, the synthesized supervisor looks like this:
                                    </p>
                                    <pre class="highlightjs highlight">
                                        <code class="language-cif hljs" data-lang="cif">
                                            supervisor automaton sup:
                                                alphabet counter.c_dec, counter.c_inc;

                                                location:
                                                    initial;
                                                    marked;
                                                    edge counter.c_dec when counter.count != 0;
                                                    edge counter.c_inc when counter.count != 8;
                                            end
                                        </code>
                                    </pre>
                                </div>
                            </div>
                        </div>
                    </div>

                    <h2>Exercise 6</h2>
                    <p>
                        Consider two machines that require a shared resource to product a product.
                        Both machines follows the same steps when producing a product:
                    </p>
                    <ul>
                        <li>They start to produce the product.</li>
                        <li>They prepare the product.</li>
                        <li>At some point they have produced the product.</li>
                        <li>And then they wait until the product has cooled down before they are finished.</li>
                    </ul>
                    <p>
                        <strong>a. Model the plant of this system (the two machines).</strong>
                    </p>
                    <p>
                        The supervisor may only control the first of the steps.
                    </p>
                    <div class="accordion" id="exercise6a-accordion">
                        <div class="accordion-item">
                            <h2 class="accordion-header">
                                <button class="accordion-button collapsed" type="button" data-bs-toggle="collapse" data-bs-target="#exercise6a-solution" aria-expanded="false" aria-controls="exercise6a-solution">
                                    Show solution
                                </button>
                            </h2>
                            <div id="exercise6a-solution" class="accordion-collapse collapse" data-bs-parent="#exercise6a-accordion">
                                <div class="accordion-body">
                                    <p>
                                        Since we have two identical machines, we use an automaton definition and instantiate it twice.
                                        Given the four steps, we have four locations four three events.
                                        Since the supervisor may only control the first step, only the first event is controllable, and the remaining ones are uncontrollable.
                                    </p>
                                    <pre class="highlightjs highlight">
                                        <code class="language-cif hljs" data-lang="cif">
                                            plant def Machine():
                                                controllable c_start;
                                                uncontrollable u_prepared, u_produced, u_cooled;

                                                location Idle:
                                                    initial;
                                                    marked;
                                                    edge c_start goto Preparing;

                                                location Preparing:
                                                    edge u_prepared goto Producing;

                                                location Producing:
                                                    edge u_produced goto CoolDown;

                                                location CoolDown:
                                                    edge u_cooled goto Idle;
                                            end

                                            machine1: Machine();
                                            machine2: Machine();
                                        </code>
                                    </pre>
                                </div>
                            </div>
                        </div>
                    </div>
                    <p>
                        <strong>b. Model the mutual-exclusion requirement and synthesize a supervisor.</strong>
                    </p>
                    <p>
                        Make sure that the two machines are not producing a product at the same time.
                        Think of the best way to model this requirement, trying different requirement forms.
                        Explain the guards of the synthesized supervisor.
                    </p>
                    <div class="accordion" id="exercise6b-accordion">
                        <div class="accordion-item">
                            <h2 class="accordion-header">
                                <button class="accordion-button collapsed" type="button" data-bs-toggle="collapse" data-bs-target="#exercise6b-solution" aria-expanded="false" aria-controls="exercise6b-solution">
                                    Show solution
                                </button>
                            </h2>
                            <div id="exercise6b-solution" class="accordion-collapse collapse" data-bs-parent="#exercise6b-accordion">
                                <div class="accordion-body">
                                    <p>
                                        The requirement can be most intuitively modeled by a state requirement invariant.
                                        It directly captures the requirement that the two machines may not be producing at the same time:
                                    </p>
                                    <pre class="highlightjs highlight">
                                        <code class="language-cif hljs" data-lang="cif">
                                            requirement not (machine1.Producing and machine2.Producing);
                                        </code>
                                    </pre>
                                    <p>
                                        The supervisor that is synthesized looks like this:
                                    </p>
                                    <pre class="highlightjs highlight">
                                        <code class="language-cif hljs" data-lang="cif">
                                            supervisor automaton sup:
                                                alphabet machine1.c_start, machine2.c_start;

                                                location:
                                                    initial;
                                                    marked;
                                                    edge machine1.c_start when machine2.Idle or machine2.CoolDown;
                                                    edge machine2.c_start when machine1.Idle or machine1.CoolDown;
                                            end
                                        </code>
                                    </pre>
                                    <p>
                                        If one machine is producing, then the other may not produce.
                                        But, producing a product can't be prevented, and neither can preparing a product, since the supervisor only has control over starting the process.
                                        Synthesis thus prevents a machine from starting if the other machine is preparing or producing.
                                        In other words, it only allows a machine to start if the other machine is either idle or letting a produced product cool down.
                                        The latter is fine, as after cooling down the machine is idle again, and it won't start due to the supervisor restricting that.
                                        A maximally permissive supervisor therefore allows one machine to start, while the other is still cooling down the produced product.
                                    </p>
                                    <p>
                                        We could also use state/event exclusion invariants to restrict the <code>u_prepared</code> events leading to the <code>Producing</code> locations:
                                    </p>
                                    <pre class="highlightjs highlight">
                                        <code class="language-cif hljs" data-lang="cif">
                                            requirement machine1.u_prepared needs not machine2.Producing;
                                            requirement machine2.u_prepared needs not machine1.Producing;
                                        </code>
                                    </pre>
                                    <p>
                                        Also in this case, as uncontrollable events may not be restricted by the supervisor, the restrictions are pushed back to the <code>c_start</code> events.
                                        The controlled system then has the same behavior.
                                        Alternatively, we can impose the exact same restrictions that the synthesized supervisors impose on the <code>c_start</code> events:
                                    </p>
                                    <pre class="highlightjs highlight">
                                        <code class="language-cif hljs" data-lang="cif">
                                            requirement machine1.u_prepared needs not machine2.Producing;
                                            requirement machine2.u_prepared needs not machine1.Producing;
                                        </code>
                                    </pre>
                                    <p>
                                        In this case, the requirements are enough, and the supervisor does not need to restrict anything extra:
                                    </p>
                                    <pre class="highlightjs highlight">
                                        <code class="language-cif hljs" data-lang="cif">
                                            supervisor automaton sup:
                                                alphabet machine1.c_start, machine2.c_start;

                                                location:
                                                    initial;
                                                    marked;
                                                    edge machine1.c_start when true;
                                                    edge machine2.c_start when true;
                                            end
                                        </code>
                                    </pre>
                                    <p>
                                        We can also model the requirement by a requirement automaton:
                                    </p>
                                    <pre class="highlightjs highlight">
                                        <code class="language-cif hljs" data-lang="cif">
                                            requirement MutualExclusive:
                                                location NotProducing:
                                                    initial;
                                                    marked;
                                                    edge machine1.u_prepared goto Producing1;
                                                    edge machine2.u_prepared goto Producing2;

                                                location Producing1:
                                                    edge machine1.u_produced goto NotProducing;

                                                location Producing2:
                                                    edge machine2.u_produced goto NotProducing;
                                            end
                                        </code>
                                    </pre>
                                    <p>
                                        As soon as we're done preparing, we are producing.
                                        If one machine is producing, we must finish that and have produced the product, before another product may be in production.
                                    </p>
                                    <p>
                                        The requirement automaton is obviously much longer than the requirement invariants.
                                        The state requirement invariant is the most direct in this case, and therefore is preferred over the state/event exclusion requirement invariants.
                                    </p>
                                </div>
                            </div>
                        </div>
                    </div>

                    <h2 id="exercise7">Exercise 7</h2>
                    <p>
                        Consider again the elevator from Exercise 3, and specifically the plant model given as the solution to Exercise 3a, so without the requirement and supervisor.
                        In the course files, you'll find in the <code>module4</code> folder, an SVG file named <code>elevator.svg</code>:
                    </p>
                    <img src="images/elevator.svg">
                    <p>
                        The left side has a building, represented by the outer rectangle.
                        Within it are three smaller rectangles, indicating the floors.
                        The elevator is depicted by the dark-grey rectangle that is positioned at the bottom floor.
                        To the right of each floor is an orange circle, indicating the sensor for that floor.
                    </p>
                    <p>
                        <strong>a. Update the image based on the plant state.</strong>
                    </p>
                    <p>
                        Connect the SVG image to the plant model.
                        Add SVG output mappings to animate the image:
                    </p>
                    <ul>
                        <li>
                            Make sure the elevator moves to the correct floor, by changing the <code>y</code> coordinate of the <code>elevator</code> element.
                            Initially, it is at <code>y</code> position <code>110</code>.
                            Each floor is 50 pixels high, and SVG counts y positions from the top, so the higher you want the elevator to be, the smaller its <code>y</code> value should be.
                        </li>
                        <li>
                            Make the circle for the sensor of each floor disappear if the elevator is not at that floor, and appear if the elevator is at that floor.
                            The SVG element ids for the sensors are <code>sensor-top</code>, <code>sensor-middle</code> and <code>sensor-bottom</code>.
                            You can use the <code>display</code> attribute for show or hide an element.
                            Value <code>none</code> means an element is not displayed, while value <code>inherit</code> can be used to display the element.
                        </li>
                    </ul>
                    <p>
                        Validate your visualization connection by simulating the adapted plant model.
                    </p>
                    <div class="accordion" id="exercise7a-accordion">
                        <div class="accordion-item">
                            <h2 class="accordion-header">
                                <button class="accordion-button collapsed" type="button" data-bs-toggle="collapse" data-bs-target="#exercise7a-solution" aria-expanded="false" aria-controls="exercise7a-solution">
                                    Show solution
                                </button>
                            </h2>
                            <div id="exercise7a-solution" class="accordion-collapse collapse" data-bs-parent="#exercise7a-accordion">
                                <div class="accordion-body">
                                    <p>
                                        An <code>svgfile</code> declaration is added at the top of the model.
                                    </p>
                                    <p>
                                        The <code>Sensor</code> plant definition gets an extra parameter named <code>floorName</code>.
                                        Note that we use <code>floorName</code> rather than just <code>floor</code>, since <code>floor</code> is a keyword in CIF.
                                        The automaton instantiations give the correct name for the particular floor.
                                        Within the <code>Sensor</code> plant definition there is a single SVG output mapping to make the sensor appear or disappear.
                                        Because it is in the definition, each instantiation gets such a mapping.
                                    </p>
                                    <p>
                                        The mapping itself selects the relevant SVG element id, by adding to the fixed name <code>sensor-</code> the floor name.
                                        The value of the <code>display</code> is either <code>inherit</code> if the sensor is in its <code>On</code> location, or <code>none</code> otherwise, so when it is in its <code>Off</code> location.
                                    </p>
                                    <p>
                                        For the elevator, the value of its <code>y</code> attribute is changed using an <code>if</code> expression.
                                        If the elevator is at the bottom, it has value <code>110</code>.
                                        If it is at the middle, it is 50 less, so <code>60</code>.
                                        And otherwise, when being at the top floor, it has value <code>10</code>.
                                    </p>
                                    <pre class="highlightjs highlight">
                                        <code class="language-cif hljs" data-lang="cif">
                                            svgfile "elevator.svg";

                                            plant def Sensor(alg string floorName; alg bool initialOn; location isOn):
                                                uncontrollable u_on, u_off;

                                                location Off:
                                                    initial not initialOn;
                                                    marked not initialOn;
                                                    edge u_on  when     isOn goto On;

                                                location On:
                                                    initial initialOn;
                                                    marked initialOn;
                                                    edge u_off when not isOn goto Off;

                                                svgout id "sensor-" + floorName attr "display" value if On: "inherit" else "none" end;
                                            end

                                            sensor_top:    Sensor("top",    false, elevator.Top);
                                            sensor_middle: Sensor("middle", false, elevator.Middle);
                                            sensor_bottom: Sensor("bottom", true,  elevator.Bottom);

                                            plant elevator:
                                                controllable c_up, c_down;

                                                location Bottom:
                                                    initial;
                                                    marked;
                                                    edge c_up goto Middle;

                                                location Middle:
                                                    edge c_down goto Bottom;
                                                    edge c_up goto Top;

                                                location Top:
                                                    edge c_down goto Middle;

                                                svgout id "elevator" attr "y" value if Bottom: "110" elif Middle: "60" else "10" end;
                                            end
                                        </code>
                                    </pre>
                                </div>
                            </div>
                        </div>
                    </div>
                    <p>
                        <strong>b. Adapt the elevator plant to represent the floor its on using a ranged integer variable.</strong>
                    </p>
                    <p>
                        So, instead of multiple locations, use a discrete variable.
                        Use one for the bottom floor, two for the middle floor, and three for the top floor.
                        Adapt the rest of the plant model, including the SVG output mappings, to fit the changed elevator plant.
                        The SVG image does not have to be changed.
                    </p>
                    <div class="accordion" id="exercise7b-accordion">
                        <div class="accordion-item">
                            <h2 class="accordion-header">
                                <button class="accordion-button collapsed" type="button" data-bs-toggle="collapse" data-bs-target="#exercise7b-solution" aria-expanded="false" aria-controls="exercise7b-solution">
                                    Show solution
                                </button>
                            </h2>
                            <div id="exercise7b-solution" class="accordion-collapse collapse" data-bs-parent="#exercise7b-accordion">
                                <div class="accordion-body">
                                    <p>
                                        The <code>elevator</code> automaton gets a <code>floorNr</code> variable, with type <code>int[1..3]</code>.
                                        Its three locations get replaced by a single location, with then doesn't need a name anymore.
                                        There are two edges, one for going up and one for going down.
                                        They update the floor number, and are guarded to prevent the variable from going outside its range.
                                    </p>
                                    <p>
                                        The SVG output mapping for the elevator's <code>y</code> position is also adapted, to check for values of the variable instead of being in a certain location.
                                    </p>
                                    <p>
                                        Given that the elevator doesn't have locations anymore, we change the <code>isOn</code> parameter of the <code>Sensor</code> definition to an algebraic boolean parameter.
                                        And we update the instantiations to use the floor number rather than the locations.
                                    </p>
                                    <pre class="highlightjs highlight">
                                        <code class="language-cif hljs" data-lang="cif">
                                            svgfile "elevator.svg";

                                            plant def Sensor(alg string floorName; alg bool initialOn; alg bool isOn):
                                                uncontrollable u_on, u_off;

                                                location Off:
                                                    initial not initialOn;
                                                    marked not initialOn;
                                                    edge u_on  when     isOn goto On;

                                                location On:
                                                    initial initialOn;
                                                    marked initialOn;
                                                    edge u_off when not isOn goto Off;

                                                svgout id "sensor-" + floorName attr "display" value if On: "inherit" else "none" end;
                                            end

                                            sensor_top:    Sensor("top",    false, elevator.floorNr = 3);
                                            sensor_middle: Sensor("middle", false, elevator.floorNr = 2);
                                            sensor_bottom: Sensor("bottom", true,  elevator.floorNr = 1);

                                            plant elevator:
                                                controllable c_up, c_down;
                                                disc int[1..3] floorNr = 1;

                                                location:
                                                    initial;
                                                    marked;
                                                    edge c_up   when floorNr &lt; 3 do floorNr := floorNr + 1;
                                                    edge c_down when floorNr &gt; 1 do floorNr := floorNr - 1;

                                                svgout id "elevator" attr "y" value if floorNr = 1: "110" elif floorNr = 2: "60" else "10" end;
                                            end
                                        </code>
                                    </pre>
                                </div>
                            </div>
                        </div>
                    </div>
                    <p>
                        <strong>c. Adapt the SVG output mapping for the elevator's y position to not use an <code>if</code> or <code>switch</code> expression, but a computation based on the floor number.</strong>
                    </p>
                    <div class="accordion" id="exercise7c-accordion">
                        <div class="accordion-item">
                            <h2 class="accordion-header">
                                <button class="accordion-button collapsed" type="button" data-bs-toggle="collapse" data-bs-target="#exercise7c-solution" aria-expanded="false" aria-controls="exercise7c-solution">
                                    Show solution
                                </button>
                            </h2>
                            <div id="exercise7c-solution" class="accordion-collapse collapse" data-bs-parent="#exercise7c-accordion">
                                <div class="accordion-body">
                                    <p>
                                        The floor number relates to the elevator's y position as follows:
                                    </p>
                                    <table class="table">
                                        <tr>
                                            <th>Floor number</th>
                                            <th>Y position</th>
                                            <th>Y position computation</th>
                                        </tr>
                                        <tr>
                                            <td>3</td>
                                            <td>10</td>
                                            <td>10 + 0</td>
                                        </tr>
                                        <tr>
                                            <td>2</td>
                                            <td>60</td>
                                            <td>10 + 50</td>
                                        </tr>
                                        <tr>
                                            <td>1</td>
                                            <td>110</td>
                                            <td>10 + 2 * 50</td>
                                        </tr>
                                    </table>
                                    <p>
                                        So, the top floor has y position 10.
                                        For each floor below it, the y position increases by 50.
                                        We can thus compute the number of times that 50 needs to be added as <code>3 - floorNr</code>.
                                        We can multiply that by 50, giving us <code>(3 - floorNr) * 50</code>.
                                        We can add the base value of 10 to it, giving us <code>10 + ((3 - floorNr) * 50)</code>.
                                        And we can convert the resulting number to a text by casting it to a <code>string</code> type, giving us <code>&lt;string&gt;(10 + ((3 - floorNr) * 50))</code>.
                                        We then get the following SVG output mapping:
                                    </p>
                                    <pre class="highlightjs highlight">
                                        <code class="language-cif hljs" data-lang="cif">
                                            svgout id "elevator" attr "y" value &lt;string&gt;(10 + ((3 - floorNr) * 50));
                                        </code>
                                    </pre>
                                </div>
                            </div>
                        </div>
                    </div>
                    <p>
                        <strong>d. Adapt the plant model with three buttons, one at each floor, allowing a user to request the elevator to move to that floor.</strong>
                    </p>
                    <p>
                        Add the buttons.
                        Also add observer automata that capture that the button was pressed.
                        Such an observer only resets to no longer being requested when the elevator is at or arrives at the particular floor.
                        Do not yet map the buttons or observers to the SVG image.
                        Also do not yet add any requirements to ensure the proper behavior of the button.
                    </p>
                    <div class="accordion" id="exercise7d-accordion">
                        <div class="accordion-item">
                            <h2 class="accordion-header">
                                <button class="accordion-button collapsed" type="button" data-bs-toggle="collapse" data-bs-target="#exercise7d-solution" aria-expanded="false" aria-controls="exercise7d-solution">
                                    Show solution
                                </button>
                            </h2>
                            <div id="exercise7d-solution" class="accordion-collapse collapse" data-bs-parent="#exercise7d-accordion">
                                <div class="accordion-body">
                                    <p>
                                        The model can be extended with the buttons and observers by adding the following to the model:
                                    </p>
                                    <pre class="highlightjs highlight">
                                        <code class="language-cif hljs" data-lang="cif">
                                            plant def Button():
                                                uncontrollable u_pushed, u_released;

                                                location Released:
                                                    initial;
                                                    marked;
                                                    edge u_pushed goto Pushed;

                                                location Pushed:
                                                    edge u_released goto Released;
                                            end

                                            button_top:    Button();
                                            button_middle: Button();
                                            button_bottom: Button();

                                            plant def Observer(event request; alg bool atFloor):
                                                uncontrollable u_reset;

                                                location NotRequested:
                                                    initial;
                                                    marked;
                                                    edge request goto Requested;

                                                location Requested:
                                                    edge u_reset when atFloor goto NotRequested;
                                            end

                                            observer_top:    Observer(button_top.u_pushed,    sensor_top.On);
                                            observer_middle: Observer(button_middle.u_pushed, sensor_middle.On);
                                            observer_bottom: Observer(button_bottom.u_pushed, sensor_bottom.On);
                                        </code>
                                    </pre>
                                    <p>
                                        The buttons are as we've seen before.
                                        Since we have multiple of them, we use automaton definition/instantiation.
                                    </p>
                                    <p>
                                        The observer tracks whether the elevator is requested to go to a specific floor.
                                        Initially, it is not requested, as the button is not yet pushed.
                                        By pushing the relevant button, the observer tracks that there is a request.
                                        When the elevator is at the particular floor, the request is reset, until the button is pressed again.
                                        The <code>Observer</code> definition gets an event representing the button being pushed for that floor, indicating the <code>request</code>.
                                        It also gets an algebraic boolean value indicating whether the elevator is at the particular floor, and thus the request can be reset.
                                    </p>
                                    <p>
                                        The instantiations provide the relevant button pushed event, and the sensor for that floor being on.
                                    </p>
                                </div>
                            </div>
                        </div>
                    </div>
                    <p>
                        <strong>e. Adapt the visualization for the updated plants.</strong>
                    </p>
                    <p>
                        Use the <code>elevator-with-buttons.svg</code> image:
                    </p>
                    <img src="images/elevator-with-buttons.svg">
                    <p>
                        Make the button rectangle's fill color reflect the request for the elevator to go to a particular floor.
                        Use <code>limegreen</code> for requested and <code>red</code> for not requested.
                        The SVG element ids for the buttons are <code>button-top</code>, <code>button-middle</code> and <code>button-bottom</code>.
                    </p>
                    <div class="accordion" id="exercise7e-accordion">
                        <div class="accordion-item">
                            <h2 class="accordion-header">
                                <button class="accordion-button collapsed" type="button" data-bs-toggle="collapse" data-bs-target="#exercise7e-solution" aria-expanded="false" aria-controls="exercise7e-solution">
                                    Show solution
                                </button>
                            </h2>
                            <div id="exercise7e-solution" class="accordion-collapse collapse" data-bs-parent="#exercise7e-accordion">
                                <div class="accordion-body">
                                    <p>
                                        Only the observers need to be changed:
                                    </p>
                                    <pre class="highlightjs highlight">
                                        <code class="language-cif hljs" data-lang="cif">
                                            plant def Observer(alg string floorName; event request; alg bool atFloor):
                                                uncontrollable u_reset;

                                                location NotRequested:
                                                    initial;
                                                    marked;
                                                    edge request goto Requested;

                                                location Requested:
                                                    edge u_reset when atFloor goto NotRequested;

                                                svgout id "button-" + floorName attr "fill" value if NotRequested: "red" else "limegreen" end;
                                            end

                                            observer_top:    Observer("top",    button_top.u_pushed,    sensor_top.On);
                                            observer_middle: Observer("middle", button_middle.u_pushed, sensor_middle.On);
                                            observer_bottom: Observer("bottom", button_bottom.u_pushed, sensor_bottom.On);
                                        </code>
                                    </pre>
                                    <p>
                                        The definition gets an extra parameter for the floor name, as before.
                                        The instantiations pass the relevant name.
                                        The definition also gets an SVG output mapping.
                                    </p>
                                </div>
                            </div>
                        </div>
                    </div>
                    <p>
                        <strong>f. Add SVG input mappings for the buttons.</strong>
                    </p>
                    <p>
                        Map them to the same <code>button-</code>... SVG elements that you used above.
                    </p>
                    <div class="accordion" id="exercise7f-accordion">
                        <div class="accordion-item">
                            <h2 class="accordion-header">
                                <button class="accordion-button collapsed" type="button" data-bs-toggle="collapse" data-bs-target="#exercise7f-solution" aria-expanded="false" aria-controls="exercise7f-solution">
                                    Show solution
                                </button>
                            </h2>
                            <div id="exercise7f-solution" class="accordion-collapse collapse" data-bs-parent="#exercise7f-accordion">
                                <div class="accordion-body">
                                    <p>
                                        The only change we need is to add an SVG input mapping to the <code>Observer</code> definition:
                                    </p>
                                    <pre class="highlightjs highlight">
                                        <code class="language-cif hljs" data-lang="cif">
                                            svgin id "button-" + floorName event request;
                                        </code>
                                    </pre>
                                    <p>
                                        Whenever a button is clicked during simulation, the corresponding request event, so the button pushed event for that particular floor, gets enabled.
                                        The button is then thus pushed, and the observer tracks that request.
                                        Since the button release is not connected to a button click, it will happen soon afterwards.
                                    </p>
                                    <p>
                                        Remember that if you want to simulate a model with SVG interaction, you need to configure the SVG input mode.
                                        Also note that if you do simulate this adapted model, the elevator's movement is not restricted by the image clicks, so it will move arbitrarily.
                                    </p>
                                </div>
                            </div>
                        </div>
                    </div>
                    <p>
                        <strong>Final remarks</strong>
                    </p>
                    <p>
                        We continue with this model in the next module, adding timing for the movement of the elevator, and synthesizing a supervisor to control it based on the floor requests.
                    </p>

                    <div class="course-navigation-footer">
                        <div class="course-navigation-prev"><a href="introduction-to-svg-visualization.html">Go back to Module 4.6</a></div>
                        <div class="course-navigation-separator">|</div>
                        <div class="course-navigation-next"><a href="water-lock-case-requirements-and-supervisor.html">Proceed to Module 4.8</a></div>
                    </div>

                </div>
            </div>
        </div>

        <!-- Footer -->
        <div class="container" id="footer">
            <footer class="pt-3 mt-4">
                <ul class="nav justify-content-center border-top pb-1 mb-1">
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.org">Eclipse Home</a></li>
                    <li class="nav-link disabled text-muted">|</li>
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.org/legal/privacy.php">Eclipse Privacy Policy</a></li>
                    <li class="nav-link disabled text-muted">|</li>
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.org/legal/termsofuse.php">Eclipse Terms of Use</a></li>
                    <li class="nav-link disabled text-muted">|</li>
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.org/legal/copyright.php">Eclipse Copyright Agent</a></li>
                    <li class="nav-link disabled text-muted">|</li>
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.org/legal">Eclipse Legal</a></li>
                    <li class="nav-link disabled text-muted">|</li>
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.dev/escet/legal.html">Eclipse ESCET Legal</a></li>
                </ul>
                <p class="text-center text-muted">Copyright © 2010, 2025 Contributors to the Eclipse Foundation</p>
            </footer>
        </div>

    </body>
</html>
